

.code

Demo3 proc uses edi esi ebx, p:ptr RADBGSTATE, dwAddress
	LOCAL disp:dword
	LOCAL line:IMAGEHLP_LINE
	LOCAL sym[sizeof IMAGEHLP_SYMBOL+0FFh]:BYTE

	assume edi:ptr RADBGSTATE
	mov edi,p
	invoke RADbgLog,T("CONTEXT",CRLF);
	invoke ThreadFromID,edi,[edi].de.dwThreadId
	invoke ShowCtx,eax
	invoke RADbgLog,T(CRLF);

	invoke RADbgLog,T("--- Symbol apis ---",CRLF,CRLF)
	mov line.SizeOfStruct,sizeof line
	mov disp,0
	invoke SymGetLineFromAddr,[edi].ps.hProcess,dwAddress,addr disp,addr line
	.if eax

		invoke RADbgLog,T("hardware bp occured on line : ",CRLF)
		;; load up the file in raedit and highlite current line
		invoke RADbgLog,T("%.8X %u: %s",CRLF),line.Address,line.LineNumber,line.FileName
		
	.endif
	
	ret
Demo3 endp

; dwAddress == [edi].de.u.ExceptionRecord.ExceptionAddress
Demo2 proc uses edi esi ebx, p:ptr RADBGSTATE, dwAddress
	
	LOCAL disp:dword
	LOCAL line:IMAGEHLP_LINE
	LOCAL sym[sizeof IMAGEHLP_SYMBOL+0FFh]:BYTE

	assume edi:ptr RADBGSTATE
	mov edi,p
	invoke RADbgLog,T("CONTEXT",CRLF);
	invoke ThreadFromID,edi,[edi].de.dwThreadId
	invoke ShowCtx,eax
	invoke RADbgLog,T(CRLF);

	invoke RADbgLog,T("--- Symbol apis ---",CRLF,CRLF)
	mov line.SizeOfStruct,sizeof line
	mov disp,0
	invoke SymGetLineFromAddr,[edi].ps.hProcess,dwAddress,addr disp,addr line
	.if eax

		invoke RADbgLog,T("bp occured on line : ",CRLF)
		;; load up the file in raedit and highlite current line
		invoke RADbgLog,T("%.8X %u: %s",CRLF),line.Address,line.LineNumber,line.FileName
		lea esi,sym
		assume esi:ptr IMAGEHLP_SYMBOL
		mov [esi].SizeOfStruct,sizeof sym
		mov [esi].MaxNameLength,0FFh

		invoke SymGetSymFromAddr,[edi].ps.hProcess,[edi].pe.Entrypoint,addr disp,esi
		.if eax
			invoke RADbgLog,T("%u+%u: %s",CRLF),[esi].Size_,disp,addr [esi].Name_
		.endif

		;; To step over:
		mov ebx,line.Address
		.repeat
			invoke SymGetLineNext,[edi].ps.hProcess,addr line
		.until (line.Address>ebx)

		invoke RADbgLog,T("I'm setting bp on next line BUT via Hardware Breakpoints this time : ",CRLF)
		invoke RADbgLog,T("%.8X %u: %s",CRLF),line.Address,line.LineNumber,line.FileName
		
		;int 3
		invoke ThreadFromID,edi,[edi].de.dwThreadId
		invoke SetThreadBpm,eax,line.Address,\
			BPM_EX, BPM_B,\;; <- Execute, Byte
			offset Demo3
		
	.else
		invoke RADbgLog,T("!!! [ERROR] SymGetLineFromAddr",CRLF)
	.endif

	
	return FALSE
	assume edi:nothing,esi:nothing,ebx:nothing
	
Demo2 endp


;; 
Demo proc uses edi esi ebx, p:ptr RADBGSTATE, dwAddress
	
	LOCAL disp:dword
	LOCAL line:IMAGEHLP_LINE
	LOCAL sym[sizeof IMAGEHLP_SYMBOL+0FFh]:BYTE

	assume edi:ptr RADBGSTATE
	
	mov edi,p
	invoke RADbgLog,T("CONTEXT",CRLF);
	invoke ThreadFromID,edi,[edi].de.dwThreadId
	invoke ShowCtx,eax
	invoke RADbgLog,T(CRLF);

	invoke RADbgLog,T("--- Symbol apis ---",CRLF,CRLF)
	mov line.SizeOfStruct,sizeof line
	mov disp,0
	invoke SymGetLineFromAddr,[edi].ps.hProcess,[edi].pe.Entrypoint,addr disp,addr line
	.if eax

		;; load up the file in raedit and highlite current line (Entrypoint)
		invoke RADbgLog,T("Current Line is : ",CRLF)
		invoke RADbgLog,T("%.8X %u: %s",CRLF),line.Address,line.LineNumber,line.FileName
		lea esi,sym
		assume esi:ptr IMAGEHLP_SYMBOL
		mov [esi].SizeOfStruct,sizeof sym
		mov [esi].MaxNameLength,0FFh
		invoke SymGetSymFromAddr,[edi].ps.hProcess,[edi].pe.Entrypoint,addr disp,esi
		.if eax
			invoke RADbgLog,T("%u+%u: %s",CRLF),[esi].Size_,disp,addr [esi].Name_
		.endif
		;; To step over:
		mov ebx,line.Address
		.repeat
			invoke SymGetLineNext,[edi].ps.hProcess,addr line
			
		.until (line.Address>ebx)

		invoke RADbgLog,T("I'm setting bp on next line : ",CRLF)
		invoke RADbgLog,T("%.8X %u: %s",CRLF),line.Address,line.LineNumber,line.FileName
		invoke RADbgSetBpx,edi,line.Address,offset Demo2
		
	.else
		invoke RADbgLog,T("[ERROR] SymGetLineFromAddr",CRLF)
	.endif
	ret
	assume edi:nothing,esi:nothing,ebx:nothing
	
Demo endp

BpxManager proc uses esi edi ebx, p:ptr RADBGSTATE; exdi:dword,dwTid:dword
	
	LOCAL pth:PRADBGTHREAD

	assume edi:ptr RADBGSTATE, ebx:ptr EXCEPTION_DEBUG_INFO
	
	mov edi,p
	lea ebx,[edi].RADBGSTATE.de.u
	invoke ThreadFromID,edi,[edi].de.dwThreadId
	mov pth,eax
	mov eax,[edi].ps.dwBreakPointSource
	.if eax == BP_SOURCE_NORMAL

		invoke RADbgLog,T('[EVENT] Exception :: BP_SOURCE_NORMAL',CRLF)

		invoke ArrayLookup,[edi].ps.pBpxBuff,sizeof RABPX,[edi].ps.dwMaxBpx,[ebx].ExceptionRecord.ExceptionAddress,RABPX.VA
		mov esi,eax
		.if eax == -1
			return FALSE
		.endif
		;; Decrease eip by size of int3
		invoke GetCtx,pth,CTX_REGS
		dec [eax].CONTEXT.Eip_
		invoke SetCtx,pth
		
		imul ecx,esi,sizeof RABPX
		add ecx,[edi].ps.pBpxBuff
		mov edx,[ecx].RABPX.pHandler
		.if edx
			invoke (BP_HANDLER_PROC ptr edx),edi,[ebx].ExceptionRecord.ExceptionAddress
			.if eax != FALSE ; Continious (Sticky) Bpx
		 		; store bpx to lastbpx
				imul ecx,esi,sizeof RABPX
				add ecx,[edi].ps.pBpxBuff
				invoke memcpy,addr [edi].ps.LastBpx,ecx,sizeof RABPX
				; trace over once
				mov [edi].ps.dwSingleStep,SS_RESTORE_BPX 
				invoke GetCtx,pth,CTX_REGS
				mov eax,pth
				or [eax].RADBGTHREAD.ctx.ContextFlags,EFLAGS_TF
				invoke SetCtx,pth
		 	.endif
			invoke RADbgClearBpx,p,esi
			
		.endif
		
		return TRUE
		
	.elseif eax == BP_SOURCE_ON_OEP
		
		invoke RADbgLog,T('[EVENT] Exception :: BP_SOURCE_ON_OEP',CRLF)
		movzx eax,byte ptr [edi].ps.EntryPointByte
		invoke RADbgWriteMemB,edi,[edi].pe.Entrypoint,eax
		;invoke FlushInstructionCache,.hProcess,.pe.Entrypoint,1
		;; Decrease eip by size of int3
		invoke GetCtx,pth,CTX_REGS
		dec [eax].CONTEXT.Eip_
		invoke SetCtx,pth
		m2m [edi].ps.dwBreakPointSource,BP_SOURCE_NORMAL
		
;### SEE - NOTE1: ###
		invoke Demo,p,[ebx].ExceptionRecord.ExceptionAddress
		
		return TRUE
		
	.elseif eax == BP_SOURCE_DBGBREAK

		invoke RADbgLog,T('[EVENT] Exception :: BP_SOURCE_DBGBREAK',CRLF)
		invoke RADbgReadMemB,edi,[edi].pe.Entrypoint
		mov byte ptr [edi].ps.EntryPointByte,al
		invoke RADbgWriteMemB,edi,[edi].pe.Entrypoint,Int3
		m2m [edi].ps.dwBreakPointSource,BP_SOURCE_ON_OEP
		return TRUE
		
	.endif
	return FALSE
	assume edi:nothing,esi:nothing,ebx:nothing
	
BpxManager endp

BpmManager proc  uses esi edi ebx, p:ptr RADBGSTATE; exdi:dword,dwTid:dword
	
	LOCAL pth:PRADBGTHREAD
	LOCAL drX:DWORD
	 

	assume edi:ptr RADBGSTATE, esi:ptr DEBUG_EVENT, ebx:ptr EXCEPTION_DEBUG_INFO

	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u

	invoke ThreadFromID,edi,[esi].dwThreadId
	mov pth,eax
	test eax,eax
	jz @@Unhandled	
	invoke GetCtx,pth,CTX_REGS or CTX_DR
	mov edx,pth
	mov eax,[edi].ps.dwSingleStep
	.if eax == SS_BP
		mov edi,[edx].RADBGTHREAD.ctx.Dr6_
		and edi,1111b; 8,4,2,1
		shr edi,1;     4,2,1,0 
		cmp edi,4
		adc edi,-1;    3,2,1,0
		mov drX,edi;   3,2,1,0
		imul eax,edi,sizeof RABPM
		lea esi,[edx].RADBGTHREAD.BpmBuff[eax]
		assume esi:ptr RABPM
		mov ecx,[edx].RADBGTHREAD.ctx.Dr0_[edi*4]
		;; ECX is DR0 or DR1 or DR2 or DR3
		mov eax,[esi].RABPM.pHandler
		cmp ecx,[esi].VA
		jnz @@Unhandled
		test eax,eax
		jz @@Unhandled
		mov ecx,[edx].RADBGTHREAD.ctx.Eip_
		invoke (BP_HANDLER_PROC ptr eax),p,[ebx].ExceptionRecord.ExceptionAddress
		.if [esi].RABPM.Access == BPM_EX;; Only _EXECUTE_ Types are restored
		 	.if eax != FALSE  ;Continious
		 		mov ecx,pth
				invoke memcpy,addr [ecx].RADBGTHREAD.LastBpm,esi,sizeof RABPM
				mov edi,p
				mov [edi].ps.dwSingleStep,SS_RESTORE_BPM
				invoke GetCtx,pth,CTX_REGS
		 		mov ecx,pth
				or [ecx].RADBGTHREAD.ctx.ContextFlags,EFLAGS_TF
	 			invoke SetCtx,pth
		 	.endif
	 		invoke ClearThreadBpm,pth,drX
	 		return TRUE
		.endif
	 	.if eax == FALSE  ;not continious
	 		invoke ClearThreadBpm,pth,drX
	 	.endif		 	
		return TRUE
		
	.elseif eax == SS_RESTORE_BPX;; STICKY SW BREAKPOINT

		invoke RADbgLog,T('***[SS_RESTORE_BPX]***')
		invoke RADbgSetBpx,edi,[edi].ps.LastBpx.VA,[edi].ps.LastBpx.pHandler
		mov [edi].ps.dwSingleStep,SS_BP
		return TRUE
		
	.elseif eax == SS_RESTORE_BPM;; STICKY HW BREAKPOINT
		invoke RADbgLog,T('***[SS_RESTORE_BPM]***')
		mov ecx,pth
		movzx eax,[ecx].RADBGTHREAD.LastBpm.Access
		movzx edx,[ecx].RADBGTHREAD.LastBpm.Len
		invoke SetThreadBpm,pth,[ecx].RADBGTHREAD.LastBpm.VA,eax,edx,\
			[ecx].RADBGTHREAD.LastBpm.pHandler
		mov [edi].ps.dwSingleStep,SS_BP
		return TRUE
	.endif	

@@Unhandled:	
	return FALSE
	assume edi:nothing,esi:nothing,ebx:nothing
	
BpmManager endp

DbgEventException proc private uses ebx edi esi, p:PRADBGSTATE

	assume edi:ptr RADBGSTATE, esi:ptr DEBUG_EVENT, ebx:ptr EXCEPTION_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	mov [edi].dwContinueStatus,DBG_CONTINUE;DBG_EXCEPTION_NOT_HANDLED
	
	.if [ebx].ExceptionRecord.ExceptionCode == STATUS_BREAKPOINT
		invoke BpxManager,edi
		.if eax;TRUE==HANDLED
			return DBG_CONTINUE
		.endif

	.elseif [ebx].ExceptionRecord.ExceptionCode == STATUS_SINGLE_STEP
		invoke BpmManager,edi
		.if eax;TRUE==HANDLED
			return DBG_CONTINUE
		.endif
	.endif

	mov [edi].dwContinueStatus,DBG_EXCEPTION_NOT_HANDLED
	return DBG_EXCEPTION_NOT_HANDLED;

	assume edi:nothing,esi:nothing,ebx:nothing
	
DbgEventException endp

DbgEventCreateProcess proc uses ebx edi esi, p:PRADBGSTATE

	LOCAL nbr:dword, DosHdr:IMAGE_DOS_HEADER, NtHdr:IMAGE_NT_HEADERS, ut:RADBGTHREAD

	assume edi:ptr RADBGSTATE, esi:ptr DEBUG_EVENT
	mov edi,p
	assume ebx:ptr CREATE_PROCESS_DEBUG_INFO
	lea esi,[edi].de
	lea ebx,[edi].de.u

	;; add process info
	m2mr [edi].ps.hProcess,[ebx].hProcess
	m2mr [edi].ps.dwProcessId,[esi].dwProcessId
	m2mr [edi].ps.dwThreadId,[esi].dwThreadId
	m2mr [edi].ps.hThread,[ebx].hThread
	
	;; print process info
	invoke RADbgLogf,T('[EVENT] CreateProcess :: dwProcessId = %.8X',CRLF),[esi].dwProcessId
	invoke RADbgLogf,T(9,'Entrypoint  : %.8X',CRLF),[ebx].lpStartAddress
	invoke RADbgLogf,T(9,'ImageBase   : %.8X',CRLF),[ebx].lpBaseOfImage

	;; add main thread
	xor edx,edx
	mov [edi].ps.dwNumThreads,edx
	mov ut.pNext,edx
	m2mr ut.hThread,[ebx].hThread
	m2mr ut.dwThreadId,[esi].dwThreadId
	m2mr ut.StartAddress,[ebx].lpStartAddress
	invoke AddThreadToList,edi,addr ut; HEAD thread

	;; add pe info
	.if [ebx].hFile != INVALID_HANDLE_VALUE
		invoke ReadFile,[ebx].hFile,addr DosHdr,sizeof IMAGE_DOS_HEADER,addr nbr,0
		invoke SetFilePointer,[ebx].hFile,DosHdr.e_lfanew,0,FILE_BEGIN
		invoke ReadFile,[ebx].hFile,addr NtHdr,sizeof IMAGE_NT_HEADERS,addr nbr,0
		invoke SetFilePointer,[ebx].hFile,0,0,FILE_BEGIN
		invoke GetFileSize,[ebx].hFile,0
		mov [edi].pe.dwFsize,eax
		mov eax,[ebx].lpBaseOfImage
		mov [edi].pe.dwImageBase,eax
		add eax,DosHdr.e_lfanew
		mov [edi].pe.pNt,eax
		add eax,sizeof IMAGE_NT_HEADERS
		mov [edi].pe.pFirstSec,eax
		mov eax,[ebx].hFile
		mov [edi].pe.hFile,eax
		mov eax,[ebx].lpStartAddress
		mov [edi].pe.Entrypoint,eax
		mov eax,NtHdr.OptionalHeader.SizeOfImage
		mov [edi].pe.SizeOfImage,eax
		movzx eax,NtHdr.FileHeader.NumberOfSections
		mov [edi].pe.SecNum,eax
		invoke RADbgLogf,T(9,'FileSize    : %u bytes',CRLF),[edi].pe.dwFsize
	.else
		invoke RADbgLog,T(9,'ERROR!!! FILE IN USE',CRLF)
	.endif

	invoke SymInitialize,[ebx].hProcess,0,FALSE
	.if !eax
		invoke RADbgLog,T(9,'[ERROR] SymInitialize',CRLF)
	.endif
	invoke SymLoadModule,[ebx].hProcess,[ebx].hFile,addr [edi].szDebugeePath,0,[ebx].lpBaseOfImage,0
	.if !eax
		invoke RADbgLog,T(9,'[ERROR] SymLoadModule @ CreateProcess',CRLF)
	.endif
	
	imul ecx,[edi].ps.dwMaxBpx,sizeof RABPX
	invoke calloc,ecx,1
	mov [edi].ps.pBpxBuff,eax

	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing
	
DbgEventCreateProcess endp

DbgEventExitProcess proc private uses ebx edi esi, p:PRADBGSTATE

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr EXIT_PROCESS_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	invoke RADbgLogf,T('[EVENT] ExitProcess :: dwExitCode = %.8X'),[ebx].dwExitCode

	invoke free,[edi].ps.pBpxBuff

	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing

DbgEventExitProcess endp

DbgEventCreateThread proc private uses ebx edi esi, p:PRADBGSTATE

	LOCAL ut:RADBGTHREAD

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr CREATE_THREAD_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	
	invoke RADbgLogf,T('[EVENT] CreateThread [dwThreadId=%.8X] :: lpStartAddress @%.8X'),[esi].dwThreadId,[ebx].lpStartAddress

	xor ecx,ecx
	mov ut.pNext,ecx
	m2mr ut.hThread,[ebx].hThread
	m2mr ut.dwThreadId,[esi].dwThreadId
	m2mr ut.StartAddress,[ebx].lpStartAddress
	invoke AddThreadToList,edi,addr ut
	
	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing

DbgEventCreateThread endp

DbgEventExitThread proc private uses ebx edi esi, p:PRADBGSTATE

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr EXIT_THREAD_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	
	invoke RADbgLogf,T('[EVENT] ExitThread [dwThreadId=%.8X] :: dwExitCode=%.8X'),[esi].dwThreadId,[ebx].dwExitCode
	invoke DeleteThreadFromList,edi,[esi].dwThreadId
	
	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing
	
DbgEventExitThread endp

DbgEventLoadDll proc private uses ebx edi esi, p:PRADBGSTATE

	LOCAL psz1,psz2 
	LOCAL minfo:IMAGEHLP_MODULE
	
	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr LOAD_DLL_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u

	invoke calloc,MAX_PATH*2,1
	mov psz1,eax
	invoke calloc,MAX_PATH*2,1
	mov psz2,eax	
	mov eax,[esi].dwProcessId
	xor ecx,ecx
	.if [ebx].lpImageName == ecx
	@@:
		;invoke FindProcessModule,[ebx].lpBaseOfDll,psz2
		invoke RADbgLogf,T('[EVENT] LOADDLL *WARNING* lpImageName IS NULL for %.8X',CRLF),[ebx].lpBaseOfDll		
	.else
		invoke RADbgReadMemD,edi,[ebx].lpImageName
		test eax,eax
		jz @B
		invoke RADbgReadMem,edi,eax,psz1,2*MAX_PATH
		.if [ebx].fUnicode
			invoke WideCharToMultiByte,CP_ACP,0,psz1,-1,psz2,2*MAX_PATH,0,0
		.endif	
	.endif	
	invoke SymLoadModule,[edi].ps.hProcess,[ebx].hFile,psz2,0,[ebx].lpBaseOfDll,0
	.if [edi].dwOptions & RADBG_VERBOSE
		invoke RADbgLogf,T('[EVENT] LOADDLL %s @ %.8X',CRLF),psz2,[ebx].lpBaseOfDll
		m2m minfo.SizeOfStruct,sizeof IMAGEHLP_MODULE
		invoke SymGetModuleInfo,[edi].ps.hProcess,[ebx].lpBaseOfDll,addr minfo
		;invoke RADbgLogf,T(9,'%s %s : @%.8X',CRLF),addr minfo.ModuleName,\
		;addr minfo.ImageName,minfo.BaseOfImage
	.endif
	invoke free,psz1
	invoke free,psz2	
	invoke CloseHandle,[ebx].hFile			
	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing 

DbgEventLoadDll endp

DbgEventUnloadDll proc private uses ebx edi esi, p:PRADBGSTATE

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr UNLOAD_DLL_DEBUG_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	.if [edi].dwOptions & RADBG_VERBOSE
		invoke RADbgLogf,T('[EVENT] UnloadDll :: @%.8X'),[ebx].lpBaseOfDll
	.endif
	invoke SymUnloadModule,[edi].ps.hProcess,[ebx].lpBaseOfDll
	.if !eax
		invoke RADbgLogf,T('[ERROR] UNLOADDLL : @%.8X',CRLF),[ebx].lpBaseOfDll
	.endif
	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing

DbgEventUnloadDll endp

DbgEventOutputString proc private uses ebx edi esi, p:PRADBGSTATE

	LOCAL pdebugeestr:PTR BYTE
	debugeestrsize equ 400h

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT, ebx:ptr OUTPUT_DEBUG_STRING_INFO
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
		
	invoke calloc,debugeestrsize,1
	mov pdebugeestr,eax
	invoke RADbgReadMem,edi,[ebx].OUTPUT_DEBUG_STRING_INFO.lpDebugStringData,pdebugeestr,debugeestrsize-1
	invoke RADbgLogf,T('[EVENT] DebugeeString :',13,10,'%s',CRLF),pdebugeestr
	invoke free,pdebugeestr

	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing

DbgEventOutputString endp

DbgEventDefault proc private p:PRADBGSTATE

	assume edi:ptr RADBGSTATE,esi:ptr DEBUG_EVENT
	mov edi,p
	lea esi,[edi].RADBGSTATE.de
	lea ebx,[edi].RADBGSTATE.de.u
	mov [edi].dwContinueStatus,DBG_CONTINUE
	return DBG_CONTINUE
	assume edi:nothing,esi:nothing,ebx:nothing

DbgEventDefault endp

DebugCleanup proc pdbg:PRADBGSTATE
	
	mov eax,pdbg
	invoke SymCleanup,[eax].RADBGSTATE.ps.hProcess
	invoke FreeThreadList,pdbg
	invoke free,pdbg
	ret
	
DebugCleanup endp

DebugThread proc private uses esi edi ebx pradbg:PRADBGSTATE
	
	mov edi,pradbg
	lea esi,[edi].RADBGSTATE.de

	assume edi:ptr RADBGSTATE, esi:ptr DEBUG_EVENT

	invoke memset,addr [edi].pi,0,sizeof PROCESS_INFORMATION
	invoke memset,addr [edi].sinf,0,sizeof SYSTEM_INFO
	mov [edi].sinf.cb,sizeof SYSTEM_INFO
	
	invoke CreateProcess,addr [edi].szDebugeePath,addr [edi].szCmdLn,0,0,0,\
		CREATE_SUSPENDED or DEBUG_PROCESS or DEBUG_ONLY_THIS_PROCESS,0,0,\
		addr [edi].sinf,addr [edi].pi

	.if eax
		mov [edi].ps.dwBreakPointSource,BP_SOURCE_DBGBREAK
		mov [edi].ps.dwSingleStep,SS_BP
		m2mr [edi].ps.dwProcessId,[edi].pi.dwProcessId 
		m2mr [edi].ps.dwThreadId,[edi].pi.dwThreadId
		invoke ResumeThread,[edi].pi.hThread
		invoke CloseHandle,[edi].pi.hProcess
		invoke CloseHandle,[edi].pi.hThread
		.repeat
			mov [edi].dwContinueStatus,DBG_CONTINUE
			invoke WaitForDebugEvent,esi,DBGWAITTIMEOUT
			mov eax,[esi].DEBUG_EVENT.dwDebugEventCode
			and eax,0Fh;;EXCEPTION_MAXIMUM_PARAMETERS
			.break .if zero?
			.const
				align 16
				fnDbgEvent TYPEDEF PROTO STDCALL :DWORD
				;; Debug Loop Switch Case 
				DbgEventsTable label PTR fnDbgEvent ;; 10 procs
				;; EXCEPTION_MAXIMUM_PARAMETERS DUP (procs)
				DWORD offset DbgEventDefault; 0 proc
				DWORD offset DbgEventException;dd offset DbgEventDefault
				DWORD offset DbgEventCreateThread;dd offset DbgEventDefault
				DWORD offset DbgEventCreateProcess;offset DbgEventDefault
				DWORD offset DbgEventExitThread;dd offset DbgEventDefault
				DWORD offset DbgEventExitProcess;offset DbgEventDefault
				DWORD offset DbgEventLoadDll;dd offset DbgEventDefault
				DWORD offset DbgEventUnloadDll;dd offset DbgEventDefault
				DWORD offset DbgEventOutputString;dd offset DbgEventDefault
				DWORD offset DbgEventDefault
				DbgEventsTableEntries = (($-DbgEventsTable)/DWORD)
				DWORD EXCEPTION_MAXIMUM_PARAMETERS-DbgEventsTableEntries dup (offset DbgEventDefault)
			.code
			invoke DbgEventsTable[4*eax],edi
			invoke ContinueDebugEvent,[esi].dwProcessId,[esi].dwThreadId,[edi].dwContinueStatus;
            ; ON DBG_CONTINUE .continue; ON DBG_EXCEPTION_NOT_HANDLED .continue,; ON DBG_TERMINATE_PROCESS .break			
		.until [edi].dwContinueStatus == DBG_TERMINATE_PROCESS
		invoke DebugCleanup,pradbg
		invoke ExitThread,TRUE
	.endif
	invoke RADbgLog,T('[ERROR] CreateProcess')
	invoke DebugCleanup,pradbg
	invoke ExitThread,FALSE
	
	assume ebx:nothing,edi:nothing,esi:nothing
	
DebugThread endp


.code

AdjustPrivilege proc

	LOCAL hProcess:HANDLE
	LOCAL hToken:HANDLE
	LOCAL tkp:TOKEN_PRIVILEGES

	invoke GetCurrentProcess
	mov hProcess,eax
	invoke OpenProcessToken,hProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,addr hToken
	lea eax,tkp.Privileges[0].Luid 
	invoke LookupPrivilegeValue,NULL,T("SeDebugPrivilege"),eax 
	mov tkp.PrivilegeCount,1 
	mov tkp.Privileges[0].Attributes,SE_PRIVILEGE_ENABLED  
	invoke AdjustTokenPrivileges,hToken,FALSE,addr tkp, sizeof tkp, NULL, NULL
	push eax
	invoke CloseHandle,hToken
	pop eax
	ret

AdjustPrivilege endp


;;; PUBLIC/MAIN FUNCTIONS

;; the whole debugger state will be in a memory buffer NO GLOBAL VARIBLES
;; returns debugthread handle or invalid handle if error
RADbgMain proc public uses esi edi ebx ppdbg:PTR PRADBGSTATE, options:DWORD , pszFileName:PTR BYTE, pszCmdLine:PTR BYTE 

	invoke AdjustPrivilege
	.if eax
		invoke calloc,sizeof RADBGSTATE,BYTE
		.if eax
			mov esi,eax
			mov edi,ppdbg
			mov [edi],eax
			invoke GetSystemInfo,addr [esi].RADBGSTATE.sysinfo
			invoke GetFullPathName,pszFileName,MAX_PATH,addr [esi].RADBGSTATE.szDebugeePath,addr [esi].RADBGSTATE.pszDebugeeFileName
			.if pszCmdLine
				invoke strcpy,addr [esi].RADBGSTATE.szCmdLn,pszCmdLine
			.endif
			m2mr [esi].RADBGSTATE.dwOptions,options
			mov [esi].RADBGSTATE.ps.dwMaxBpx,MAX_BPX
			invoke CreateThread,0,0,offset DebugThread,esi,0,addr [esi].RADBGSTATE.dwDbgThreadID
			mov [esi].RADBGSTATE.hDbgThread,eax
			return eax
			
		.endif
	.endif
	return INVALID_HANDLE_VALUE
	
RADbgMain endp

RADbgTerminate proc uses esi, pdbg:PRADBGSTATE
	mov esi,pdbg
	invoke SuspendThread,[esi].RADBGSTATE.hDbgThread
	invoke DebugCleanup,pdbg
	invoke TerminateThread,[esi].RADBGSTATE.hDbgThread,-1
	return TRUE
RADbgTerminate endp

RADbgLoadBreakpoints proc
	ret
RADbgLoadBreakpoints endp

RADbgStepOver proc
	ret
RADbgStepOver endp

RADbgStepInto proc
	ret
RADbgStepInto endp

