
.code

AddThreadToList proc uses esi edi ebx p:PTR RADBGSTATE, pdbgt:PRADBGTHREAD
	
	invoke calloc,sizeof RADBGTHREAD,1
	mov ecx,p
	mov ebx,[ecx].RADBGSTATE.ps.pThreadList; Thread List HEAD
	mov edi,eax
	mov esi,pdbgt
	invoke memcpy,edi,esi,sizeof RADBGTHREAD
	.if ebx
		; other threads
		mov eax,ebx; first ptr
		.while [eax].RADBGTHREAD.pNext != NULL; while not TAIL
			mov eax,[eax].RADBGTHREAD.pNext
		.endw
		; eax holds last thread added - TAIL
		;
		; set new to next
		mov [eax].RADBGTHREAD.pNext,edi
	.else
		; first thread
		mov ecx,p
		mov [ecx].RADBGSTATE.ps.pThreadList,edi
	.endif
	; increas thread count
	mov ecx,p
	inc [ecx].RADBGSTATE.ps.dwNumThreads
	;invoke calloc,(sizeof TBPM)*MAX_BPM,1
	;mov [edi].RADBGTHREAD.pBpmBuff,eax
	invoke RADbgLogf,T(9,'*** threadcount: %u',CRLF),[ecx].RADBGSTATE.ps.dwNumThreads
	ret
	
AddThreadToList endp

GetThreadByID proc uses ebx esi edi p:PTR RADBGSTATE, dwTid:dword, pdbgt:PRADBGTHREAD
	
	mov edx,dwTid
	mov ebx,p
	mov ecx,[ebx].RADBGSTATE.ps.dwThreadId
	test edx,edx
	cmovz edx,ecx
	mov esi,[ebx].RADBGSTATE.ps.pThreadList; first ptr
	xor eax,eax
	.repeat
		cmp edx,[esi].RADBGTHREAD.dwThreadId
		je @F
		mov esi,[esi].RADBGTHREAD.pNext
	.until !esi
	return FALSE 
@@:	
	invoke memcpy,pdbgt,esi,sizeof RADBGTHREAD
	return TRUE
	
GetThreadByID endp


ThreadFromID proc uses ebx esi edi p:PTR RADBGSTATE, dwTid:dword
	
	mov edx,dwTid
	mov ebx,p
	mov ecx,[ebx].RADBGSTATE.ps.dwThreadId
	test edx,edx
	cmovz edx,ecx
	mov esi,[ebx].RADBGSTATE.ps.pThreadList; first ptr
	xor eax,eax
	.repeat
		cmp edx,[esi].RADBGTHREAD.dwThreadId
		je @F
		mov esi,[esi].RADBGTHREAD.pNext
	.until !esi
	ret; eax = NULL
@@:	
	return esi
	
ThreadFromID endp

FreeThreadList proc uses ebx esi edi p:PTR RADBGSTATE
	
	mov ebx,p
	mov edi,[ebx].RADBGSTATE.ps.pThreadList
	; no thread -> impossible situation - or not? 
	.if edi
		.repeat
			mov esi,edi
			; get tail
			.while [esi].RADBGTHREAD.pNext
				mov edi,esi
				xor eax,eax
				mov esi,[esi].RADBGTHREAD.pNext
				mov [edi].RADBGTHREAD.pNext,eax
			.endw
			invoke CloseHandle,[esi].RADBGTHREAD.hThread
			invoke free,esi
		.until esi == [ebx].RADBGSTATE.ps.pThreadList; have we reached the head?
	.endif
	xor eax,eax
	mov [ebx].RADBGSTATE.ps.pThreadList,eax
	mov [ebx].RADBGSTATE.ps.dwNumThreads,eax
	ret
	
FreeThreadList endp

DeleteThreadFromList proc uses ebx esi edi p:PTR RADBGSTATE, dwTid:dword

	mov ebx,p
	mov edi,[ebx].RADBGSTATE.ps.pThreadList
	mov edx,dwTid
	.if edi; to be safe
		xor ebx,ebx                       ; prev = 0
		.repeat
			cmp edx,[edi].RADBGTHREAD.dwThreadId
			je @F
			mov ebx,edi                   ; prev = curr
			mov edi,[edi].RADBGTHREAD.pNext; curr = next
		.until !edi
		return FALSE
@@:			
		mov esi,edi; esi = curr
		mov eax,[edi].RADBGTHREAD.pNext; next
		.if !ebx ;; HEAD thread?; ebx = prev
			mov [ebx].RADBGSTATE.ps.pThreadList,eax
		.else
			mov [ebx].RADBGTHREAD.pNext,eax
		.endif
		invoke CloseHandle,[esi].RADBGTHREAD.hThread
		;invoke free,[esi].RADBGTHREAD.pBpmBuff
		invoke free,esi
		dec [ebx].RADBGSTATE.ps.dwNumThreads
		invoke RADbgLogf,T(9,'*** threadcount: %u'),[ebx].RADBGSTATE.ps.dwNumThreads	
	.endif
	ret
	
DeleteThreadFromList endp
