.code
RADbgLog equ printf
RADbgLogf equ printf

ArrayLookup proc uses ebx pArray,dwElementSize,dwMax,dwValue,nValueOffset
	mov edx,pArray
	mov ebx,dwValue
	mov ecx,nValueOffset
	xor eax,eax; index
	.while ( ebx != [edx+ecx] ) && ( eax < dwMax )
		inc eax
		add edx,dwElementSize
	.endw
	cmp eax,dwMax
	sbb edx,edx
	xor edx,-1
	or eax,edx; if (Not found or >= dwBpMax) then EAX == -1 else (index 0 based)
	ret
ArrayLookup endp


; eax == number of bytes read
RADbgReadMem proc p:ptr RADBGSTATE, lpAddress:dword, lpBuffer:dword, nSize:dword
	
	LOCAL nbr:dword
	
	mov edx,p
	invoke ReadProcessMemory,[edx].RADBGSTATE.pi.hProcess,lpAddress,lpBuffer,nSize,addr nbr
	mov eax,nbr
	ret
	  
RADbgReadMem endp

RADbgReadMemD proc p:ptr RADBGSTATE,lpAddress:dword

	LOCAL dwBuff:dword, nbr:dword
	
	mov edx,p
	invoke RADbgReadMem,p,lpAddress,addr dwBuff,sizeof dword
	mov eax,dwBuff
	ret
	
RADbgReadMemD endp 

RADbgReadMemB proc p:ptr RADBGSTATE,lpAddress:dword

	LOCAL dwBuff:dword, nbr:dword

	invoke RADbgReadMem,p,lpAddress,addr dwBuff,sizeof byte
	movzx eax,byte ptr [dwBuff]
	ret
	
RADbgReadMemB endp 

; eax == number of bytes written
; edx == address rounded @page address
RADbgWriteMem proc uses ebx p:ptr RADBGSTATE,lpAddress:dword, lpBuffer:dword, nSize:dword
	
	LOCAL oldProt:dword, nbr:dword

	mov ebx,p
	invoke VirtualProtectEx,[ebx].RADBGSTATE.pi.hProcess,lpAddress,nSize,PAGE_READWRITE,addr oldProt
	invoke WriteProcessMemory,[ebx].RADBGSTATE.pi.hProcess,lpAddress,lpBuffer,nSize,addr nbr
	;invoke FlushInstructionCache,[edx].RADBGSTATE.pi.hProcess,lpAddress,nSize
	invoke VirtualProtectEx,[ebx].RADBGSTATE.pi.hProcess,lpAddress,nSize,oldProt,addr oldProt
	mov eax,nbr
	ret
	
RADbgWriteMem endp

RADbgWriteMemD proc p:ptr RADBGSTATE,lpAddress:dword, dwVal:dword
	
	invoke RADbgWriteMem,p,lpAddress,addr dwVal,sizeof dword
	ret
	
RADbgWriteMemD endp 

RADbgWriteMemB proc p:ptr RADBGSTATE,lpAddress:dword,dwVal:dword
	
	invoke RADbgWriteMem,p,lpAddress,addr dwVal,sizeof byte
	ret
	
RADbgWriteMemB endp

GetCtx proc uses esi put:PRADBGTHREAD, dwFlags:DWORD
	mov esi,put
	assume esi:ptr RADBGTHREAD
	m2mr [esi].ctx.ContextFlags,dwFlags,ecx
	invoke GetThreadContext,[esi].hThread,addr [esi].ctx
 	lea eax,[esi].ctx
	ret
	assume esi:nothing
GetCtx endp

SetCtx proc uses esi put:PRADBGTHREAD
	mov esi,put
	assume esi:ptr RADBGTHREAD
	invoke SetThreadContext,[esi].hThread,addr [esi].ctx
 	lea eax,[esi].ctx
	ret
	assume esi:nothing
SetCtx endp


ShowCtx proc put:PRADBGTHREAD
	
	LOCAL szFl[16]:byte
	LOCAL tc:CONTEXT
	
	pushad
	m2mr tc.ContextFlags,CTX_REGS
	mov edx,put
	invoke GetThreadContext,[edx].RADBGTHREAD.hThread,addr tc
	invoke strcpy,addr szFl,T('o d i s z a p c')
	mov esi,tc.ContextFlags
	lea edi,szFl
	mov edx,esi
	mov ecx,esi
	shr edx,(11-5)
	mov ebx,esi
	shr ecx,(10-5)
	mov eax,esi
	shr ebx,(09-5)
	and edx,100000b
	shr eax,(07-5)
	and ecx,100000b
	and ebx,100000b
	and eax,100000b
	sub [edi+0],dl
	sub [edi+2],cl
	sub [edi+4],bl
	sub [edi+6],al
	mov edx,esi
	mov ecx,esi
	shr edx,(06-5)
	mov ebx,esi
	shl ecx,(5-04)
	mov eax,esi
	shl ebx,(5-02)
	and edx,100000b
	shl eax,(5-00)
	and ecx,100000b
	and ebx,100000b
	and eax,100000b
	sub [edi+8],dl
	sub [edi+10],cl
	sub [edi+12],bl
	sub [edi+14],al
	invoke RADbgLogf,T(9,'EAX=%.8X EBX=%.8X ECX=%.8X EDX=%.8X ESI=%.8X   ',CRLF),\
		tc.Eax_,tc.Ebx_,tc.Ecx_,tc.Edx_,tc.Esi_
	invoke RADbgLogf,T(9,'EDI=%.8X EBP=%.8X ESP=%.8X EIP=%.8X %s',CRLF),\
		tc.Edi_,tc.Ebp_,tc.Esp_,tc.Eip_,addr szFl
	invoke RADbgLogf,T(9,'CS=%.4X DS=%.4X SS=%.4X ES=%.4X FS=%.4X GS=%.4X',CRLF),\
		tc.SegCs,tc.SegDs,tc.SegSs,tc.SegEs,tc.SegFs,tc.SegGs
	popad
	ret
ShowCtx endp
